cfg = {}

cfg.spawnpoint = {
	vector3(341.32604980469,-1396.0822753906,32.509292602539),
	-- vector3([COORDS]) [Multiple can be added if needed]
}

cfg.alertenabled = true -- [Enable Alerts when player spawns at location]

cfg.freezeonmenu = false -- [When player is on the menu it freezes the player]

-- [End of CFG]

RMenu.Add("RespawnMenu", "main", RageUI.CreateMenu("Spawn Menu", "~b~Cloned's Spawn Menu", 1350, 50))
RageUI.CreateWhile(1.0, RMenu:Get("RespawnMenu", "main"), nil, function()
	RageUI.IsVisible(RMenu:Get("RespawnMenu", "main"), true, true, true, function()
		--
        RageUI.Button("St Thomas Hospital", "A hospital spawn in ~b~City~w~.", { RightLabel = "→→→" }, true, function(Hovered, Active, Selected)
			if Selected then
				notify("~g~Teleporting to location...")
				Citizen.Wait(2000)
                SetEntityCoords(PlayerPedId(), 361.84051513672,-593.13464355469,28.664552688599)
				if cfg.alertenabled == true then
					alert("Spawned in at ~b~St Thomas Hospital")
				end
            end
        end)
		--
		RageUI.Button("Sandy Hospital", "A hospital in ~b~Sandy~w~.", { RightLabel = "→→→" }, true, function(Hovered, Active, Selected)
			if Selected then
				notify("~g~Teleporting to location...")
				Citizen.Wait(2000)

                SetEntityCoords(PlayerPedId(), 1839.7781982422,3672.0986328125,34.276706695557)

				if cfg.alertenabled == true then
					alert("Spawned in at ~b~Sandy Hospital")
				end
            end
		end)
		--
		RageUI.Button("Mission Row PD", "A teleport to the PD in city ~b~(Used for Police)", { RightLabel = "→→→" }, true, function(Hovered, Active, Selected)
			if Selected then
				notify("~g~Teleporting to location...")
				Citizen.Wait(2000)

                SetEntityCoords(PlayerPedId(), 428.19479370117,-981.58215332031,30.710285186768)

				if cfg.alertenabled == true then
					alert("Spawned in at ~b~Mission Row PD")
				end
        	end
		end)
		--
		RageUI.Button("Fleeca Bank", "Need to ~b~Withdraw/ Deposit money. ~w~Go to the bank located in ~y~Legion", { RightLabel = "→→→" }, true, function(Hovered, Active, Selected)
			if Selected then
				notify("~g~Teleporting to location...")
				Citizen.Wait(2000)

                SetEntityCoords(PlayerPedId(), 428.19479370117,-981.58215332031,30.710285186768)

				if cfg.alertenabled == true then
					alert("Spawned in at ~b~Fleeca Bank")
				end
        	end
		end)
		-- [Copy and Paste if you want more spawn vectors]
    end)
end)

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(1)
		local pedCoords, isInMenu, currentZone, menuRemove = GetEntityCoords(PlayerPedId()), false, nil, true

		for k,v in pairs(cfg.spawnpoint) do
			local distance = #(pedCoords - v)

			if distance < 120.0 then
				menuRemove = false
				if distance < 1.5 then
					isInMenu, currentZone = true, k
				end
			end
		end
		if (isInMenu and not hasAlreadyEnteredMarker) or (isInMenu and lastZone ~= currentZone) then
			hasAlreadyEnteredMarker, lastZone = true, currentZone
			RageUI.Visible(RMenu:Get("RespawnMenu", "main"), true)
			if cfg.freezeonmenu == true then
				FreezeEntityPosition(PlayerPedId(-1), true)
			end
			Ismenuopened = true
		end

		if not isInMenu and hasAlreadyEnteredMarker then
			RageUI.Visible(RMenu:Get("RespawnMenu", "main"), false)
			if cfg.freezeonmenu == true then
				FreezeEntityPosition(PlayerPedId(-1), false)
			end
			hasAlreadyEnteredMarker = false
			Ismenuopened = false
		
			Citizen.Wait(500)
		end
	end
end)

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(0)

		if Ismenuopened then
			RageUI.Visible(RMenu:Get("RESPAWN", "main"), true) 
		else 
			Citizen.Wait(500)
		end
	end
end)


function alert(msg) 
    SetTextComponentFormat("STRING")
    AddTextComponentString(msg)
    DisplayHelpTextFromStringLabel(0,0,1,-1)
end

function notify(msg)
    SetNotificationTextEntry("STRING")
    AddTextComponentString(msg)
    DrawNotification(true,false)
end




